<?php
/*
 * Free Map ver.β1.1
 * (c)2008 Cake All righ1ts reserved.
 * Mail : cake_67@users.sourceforge.jp
 * Home : http://trpgtools-onweb.sourceforge.jp/
 */

// デバッグ用設定
ini_set('log_errors', false);
ini_set('error_log', "./php_error.log");

/* 発言書込み */

// 設定ファイルの読み込み
require_once './freemap-ini.php';
require_once './lib/freemap.php';
require_once './lib/write.php';

// 設定セット
//set_config(read_config());

$host = gethostbyaddr($_SERVER['REMOTE_ADDR']);
$ua = getenv("HTTP_USER_AGENT");

// 書き込みブロック
write_block();

// アクセスブロック
//access_block();

// リクエスト受信
if (!$data = request()) {
    if (!$data = $_GET) {
        errorStop('データを受信できません');
    }
}
foreach ($data as $k => $v) {
    $data[$k] = htmlspecialchars($v);
}

// ログオン状態チェック
list($data['hs'], $data['p']) = getAuth();

// 書き込みモードがなければ書込みはできない
if ($data['m'] == '') {
    errorStop('書きこみできません。');
}
// ファイルロック
$lfp = fopen(LOCK,"w");
stream_set_write_buffer($lfp, 0);
flock($lfp,LOCK_EX);

// 既存ファイル内容の格納
$log = array();
$log = file(LOGFILE);

// 受信データの処理
$map = array_shift($log);

$tlog_flag = false;
$add_flg = false;
if (count($log)) {
    foreach ($log as $k => $v) {
        $temp[$k] = explode("<>", $v);
        // ユニット移動、編集、削除、ログアウト
        if ($data['m'] != 'add') {
            if (
                (
                    (($data['m'] == 'edit' && $temp[$k][0] == $data['on']) || ($data['m'] != 'edit' && $temp[$k][0] == rawurldecode($data['un'])))
                 && ($temp[$k][2] == $data['hs'] || !$temp[$k][2])
                 )
             || (
                    ($data['m'] == 'out' || $data['m']=='in')
                 && ($temp[$k][1] == $data['p'])
                  )
             ) {
                $tlog_flag = true;
                // ユニット削除
                if ($data['m'] == 'del') {
                    if (!$temp[$k][2]) errorStop('デモユニットは削除できません');
                    $tlog_flag = true;
                    unset($log[$k]);
                // ユニット編集
                } elseif ($data['m'] == 'edit' && $temp[$k][2] == $data['hs']) {
                    if (!$temp[$k][2]) errorStop('デモユニットは編集できません');
                    $tlog_flag = true;
                    $data['x'] = $temp[$k][3]; // x座標
                    $data['y'] = $temp[$k][4]; // y座標
                    if (!$data['w']) $data['w'] = $temp[$k][5]; // w
                    if (!$data['h']) $data['h'] = $temp[$k][6]; // h
                    if (!$data['c']) $data['c'] = $temp[$k][7]; // 背景色
                    if (!$data['sc']) $data['sc'] = $temp[$k][8]; // 文字色
                    $log[$k] = set_data($data);
                // ユニット移動、ログイン/ログアウト
                } elseif ($data['m'] == 'drop'
                     || (
                           ($data['m'] == 'out' || $data['m'] == 'in')
                         && $temp[$k][2] == $data['hs']
                           )
                        ) {
                    $del_flg = '';
                    $tlog_flag = true;
                    $data['un'] = $temp[$k][0]; // ユニット名
                    if (!$temp[$k][2]) {
                        $data['hs'] = '';
                        $data['p'] = $temp[$k][1];
                    }
                    if ($data['m']!='drop') $data['x'] = $temp[$k][3]; // x座標
                    if ($data['m']!='drop') $data['y'] = $temp[$k][4]; // y座標
                    $data['w'] = $temp[$k][5]; // w
                    $data['h'] = $temp[$k][6]; // h
                    $data['c'] = $temp[$k][7]; // 背景色
                    $data['sc'] = $temp[$k][8]; // 文字色
                    $data['st'] = $temp[$k][9]; // status
//                    $data['s'] = $temp[$k][10]; // 表示、非表示
                    if ($data['m'] == 'out') {
                        $del_flg = 1;
                    }
                    $log[$k] = set_data($data, $del_flg);
                }
            }
        } else {
            // 同じ名前のユニットは追加できない
                if ($temp[$k][0] == $data['un']) {
                $add_flg = true;
                error_log("同じ名前のユニットは追加できません");
            }
        }

        // 削除フラグが付いていて、一定時間が経過したユニットは消す
        if ($temp[$k][14] && (intval($temp[$k][11]) + intval(LOGOUT_UNIT_DELETE)*60 < intval(time()))) {
            unset($log[$k]);
        }
    }
}

// 追加
if (!$add_flg && $data['m'] == 'add' && count($log) <= UNIT_NUM && $data['p']) {
    $tlog_flag = true;
    $data['x'] = 0;
    $data['y'] = 0;
    if (!$data['w']) $data['w'] = UNIT_SIZE; // w
    if (!$data['h']) $data['h'] = UNIT_SIZE; // h
    if (!$data['c']) $data['c'] = UNIT_BG_COLOR; // 背景色
    if (!$data['sc']) $data['sc'] = UNIT_FONT_COLOR; // 文字色
    array_push($log, set_data($data));
}

array_unshift($log, $map);

// ログファイルに書込み
$fp = @fopen(LOGFILE, "w+") or error("ログファイルを開けません。");
foreach ($log as $v){
    fwrite($fp, $v);
}
fclose($fp);

// ロック解除
fflush($lfp);
fclose($lfp);

// テキストログの書き込み
if ($tlog_flag && WRITE_TEXT_LOG) update_log($data);

exit;

/* エラーログを出力して停止 */
function errorStop($msg = 'ERROR!') {
    error_log($msg);
    die($msg);
}
 ?>